Modernize t5530-upload-pack-error.
[git/dscho.git] / git-submodule.sh
blob383dc451191fef4e078e9f46aaf3fdb3190ebc9a
1 #!/bin/sh
3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
15 OPTIONS_SPEC=
16 . git-sh-setup
17 . git-parse-remote
18 require_work_tree
20 command=
21 branch=
22 reference=
23 cached=
24 files=
25 nofetch=
26 update=
27 prefix=
29 # Resolve relative url by appending to parent's url
30 resolve_relative_url ()
32 remote=$(get_default_remote)
33 remoteurl=$(git config "remote.$remote.url") ||
34 die "remote ($remote) does not have a url defined in .git/config"
35 url="$1"
36 remoteurl=${remoteurl%/}
37 while test -n "$url"
39 case "$url" in
40 ../*)
41 url="${url#../}"
42 remoteurl="${remoteurl%/*}"
44 ./*)
45 url="${url#./}"
48 break;;
49 esac
50 done
51 echo "$remoteurl/${url%/}"
55 # Get submodule info for registered submodules
56 # $@ = path to limit submodule list
58 module_list()
60 git ls-files --error-unmatch --stage -- "$@" | sane_grep '^160000 '
64 # Map submodule path to submodule name
66 # $1 = path
68 module_name()
70 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
71 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
72 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
73 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
74 test -z "$name" &&
75 die "No submodule mapping found in .gitmodules for path '$path'"
76 echo "$name"
80 # Clone a submodule
82 # Prior to calling, cmd_update checks that a possibly existing
83 # path is not a git repository.
84 # Likewise, cmd_add checks that path does not exist at all,
85 # since it is the location of a new submodule.
87 module_clone()
89 path=$1
90 url=$2
91 reference="$3"
93 # If there already is a directory at the submodule path,
94 # expect it to be empty (since that is the default checkout
95 # action) and try to remove it.
96 # Note: if $path is a symlink to a directory the test will
97 # succeed but the rmdir will fail. We might want to fix this.
98 if test -d "$path"
99 then
100 rmdir "$path" 2>/dev/null ||
101 die "Directory '$path' exists, but is neither empty nor a git repository"
104 test -e "$path" &&
105 die "A file already exist at path '$path'"
107 if test -n "$reference"
108 then
109 git-clone "$reference" -n "$url" "$path"
110 else
111 git-clone -n "$url" "$path"
112 fi ||
113 die "Clone of '$url' into submodule path '$path' failed"
117 # Add a new submodule to the working tree, .gitmodules and the index
119 # $@ = repo path
121 # optional branch is stored in global branch variable
123 cmd_add()
125 # parse $args after "submodule ... add".
126 while test $# -ne 0
128 case "$1" in
129 -b | --branch)
130 case "$2" in '') usage ;; esac
131 branch=$2
132 shift
134 -q|--quiet)
135 GIT_QUIET=1
137 --reference)
138 case "$2" in '') usage ;; esac
139 reference="--reference=$2"
140 shift
142 --reference=*)
143 reference="$1"
144 shift
147 shift
148 break
151 usage
154 break
156 esac
157 shift
158 done
160 repo=$1
161 path=$2
163 if test -z "$path"; then
164 path=$(echo "$repo" |
165 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
168 if test -z "$repo" -o -z "$path"; then
169 usage
172 # assure repo is absolute or relative to parent
173 case "$repo" in
174 ./*|../*)
175 # dereference source url relative to parent's url
176 realrepo=$(resolve_relative_url "$repo") || exit
178 *:*|/*)
179 # absolute url
180 realrepo=$repo
183 die "repo URL: '$repo' must be absolute or begin with ./|../"
185 esac
187 # normalize path:
188 # multiple //; leading ./; /./; /../; trailing /
189 path=$(printf '%s/\n' "$path" |
190 sed -e '
191 s|//*|/|g
192 s|^\(\./\)*||
193 s|/\./|/|g
194 :start
195 s|\([^/]*\)/\.\./||
196 tstart
197 s|/*$||
199 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
200 die "'$path' already exists in the index"
202 # perhaps the path exists and is already a git repo, else clone it
203 if test -e "$path"
204 then
205 if test -d "$path"/.git -o -f "$path"/.git
206 then
207 echo "Adding existing repo at '$path' to the index"
208 else
209 die "'$path' already exists and is not a valid git repo"
212 case "$repo" in
213 ./*|../*)
214 url=$(resolve_relative_url "$repo") || exit
217 url="$repo"
219 esac
220 git config submodule."$path".url "$url"
221 else
223 module_clone "$path" "$realrepo" "$reference" || exit
225 unset GIT_DIR
226 cd "$path" &&
227 # ash fails to wordsplit ${branch:+-b "$branch"...}
228 case "$branch" in
229 '') git checkout -f -q ;;
230 ?*) git checkout -f -q -b "$branch" "origin/$branch" ;;
231 esac
232 ) || die "Unable to checkout submodule '$path'"
235 git add "$path" ||
236 die "Failed to add submodule '$path'"
238 git config -f .gitmodules submodule."$path".path "$path" &&
239 git config -f .gitmodules submodule."$path".url "$repo" &&
240 git add .gitmodules ||
241 die "Failed to register submodule '$path'"
245 # Execute an arbitrary command sequence in each checked out
246 # submodule
248 # $@ = command to execute
250 cmd_foreach()
252 # parse $args after "submodule ... foreach".
253 while test $# -ne 0
255 case "$1" in
256 -q|--quiet)
257 GIT_QUIET=1
259 --recursive)
260 recursive=1
263 usage
266 break
268 esac
269 shift
270 done
272 module_list |
273 while read mode sha1 stage path
275 if test -e "$path"/.git
276 then
277 say "Entering '$prefix$path'"
278 name=$(module_name "$path")
280 prefix="$prefix$path/"
281 unset GIT_DIR
282 cd "$path" &&
283 eval "$@" &&
284 if test -n "$recursive"
285 then
286 cmd_foreach "--recursive" "$@"
288 ) ||
289 die "Stopping at '$path'; script returned non-zero status."
291 done
295 # Register submodules in .git/config
297 # $@ = requested paths (default to all)
299 cmd_init()
301 # parse $args after "submodule ... init".
302 while test $# -ne 0
304 case "$1" in
305 -q|--quiet)
306 GIT_QUIET=1
309 shift
310 break
313 usage
316 break
318 esac
319 shift
320 done
322 module_list "$@" |
323 while read mode sha1 stage path
325 # Skip already registered paths
326 name=$(module_name "$path") || exit
327 url=$(git config submodule."$name".url)
328 test -z "$url" || continue
330 url=$(git config -f .gitmodules submodule."$name".url)
331 test -z "$url" &&
332 die "No url found for submodule path '$path' in .gitmodules"
334 # Possibly a url relative to parent
335 case "$url" in
336 ./*|../*)
337 url=$(resolve_relative_url "$url") || exit
339 esac
341 git config submodule."$name".url "$url" ||
342 die "Failed to register url for submodule path '$path'"
344 upd="$(git config -f .gitmodules submodule."$name".update)"
345 test -z "$upd" ||
346 git config submodule."$name".update "$upd" ||
347 die "Failed to register update mode for submodule path '$path'"
349 say "Submodule '$name' ($url) registered for path '$path'"
350 done
354 # Update each submodule path to correct revision, using clone and checkout as needed
356 # $@ = requested paths (default to all)
358 cmd_update()
360 # parse $args after "submodule ... update".
361 orig_args="$@"
362 while test $# -ne 0
364 case "$1" in
365 -q|--quiet)
366 shift
367 GIT_QUIET=1
369 -i|--init)
370 init=1
371 shift
373 -N|--no-fetch)
374 shift
375 nofetch=1
377 -r|--rebase)
378 shift
379 update="rebase"
381 --reference)
382 case "$2" in '') usage ;; esac
383 reference="--reference=$2"
384 shift 2
386 --reference=*)
387 reference="$1"
388 shift
390 -m|--merge)
391 shift
392 update="merge"
394 --recursive)
395 shift
396 recursive=1
399 shift
400 break
403 usage
406 break
408 esac
409 done
411 if test -n "$init"
412 then
413 cmd_init "--" "$@" || return
416 module_list "$@" |
417 while read mode sha1 stage path
419 name=$(module_name "$path") || exit
420 url=$(git config submodule."$name".url)
421 update_module=$(git config submodule."$name".update)
422 if test -z "$url"
423 then
424 # Only mention uninitialized submodules when its
425 # path have been specified
426 test "$#" != "0" &&
427 say "Submodule path '$path' not initialized" &&
428 say "Maybe you want to use 'update --init'?"
429 continue
432 if ! test -d "$path"/.git -o -f "$path"/.git
433 then
434 module_clone "$path" "$url" "$reference"|| exit
435 subsha1=
436 else
437 subsha1=$(unset GIT_DIR; cd "$path" &&
438 git rev-parse --verify HEAD) ||
439 die "Unable to find current revision in submodule path '$path'"
442 if ! test -z "$update"
443 then
444 update_module=$update
447 if test "$subsha1" != "$sha1"
448 then
449 force=
450 if test -z "$subsha1"
451 then
452 force="-f"
455 if test -z "$nofetch"
456 then
457 (unset GIT_DIR; cd "$path" &&
458 git-fetch) ||
459 die "Unable to fetch in submodule path '$path'"
462 case "$update_module" in
463 rebase)
464 command="git rebase"
465 action="rebase"
466 msg="rebased onto"
468 merge)
469 command="git merge"
470 action="merge"
471 msg="merged in"
474 command="git checkout $force -q"
475 action="checkout"
476 msg="checked out"
478 esac
480 (unset GIT_DIR; cd "$path" && $command "$sha1") ||
481 die "Unable to $action '$sha1' in submodule path '$path'"
482 say "Submodule path '$path': $msg '$sha1'"
485 if test -n "$recursive"
486 then
487 (unset GIT_DIR; cd "$path" && cmd_update $orig_args) ||
488 die "Failed to recurse into submodule path '$path'"
490 done
493 set_name_rev () {
494 revname=$( (
495 unset GIT_DIR
496 cd "$1" && {
497 git describe "$2" 2>/dev/null ||
498 git describe --tags "$2" 2>/dev/null ||
499 git describe --contains "$2" 2>/dev/null ||
500 git describe --all --always "$2"
503 test -z "$revname" || revname=" ($revname)"
506 # Show commit summary for submodules in index or working tree
508 # If '--cached' is given, show summary between index and given commit,
509 # or between working tree and given commit
511 # $@ = [commit (default 'HEAD'),] requested paths (default all)
513 cmd_summary() {
514 summary_limit=-1
515 for_status=
516 diff_cmd=diff-index
518 # parse $args after "submodule ... summary".
519 while test $# -ne 0
521 case "$1" in
522 --cached)
523 cached="$1"
525 --files)
526 files="$1"
528 --for-status)
529 for_status="$1"
531 -n|--summary-limit)
532 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
533 then
535 else
536 usage
538 shift
541 shift
542 break
545 usage
548 break
550 esac
551 shift
552 done
554 test $summary_limit = 0 && return
556 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
557 then
558 head=$rev
559 test $# = 0 || shift
560 elif test -z "$1" -o "$1" = "HEAD"
561 then
562 return
563 else
564 head="HEAD"
567 if [ -n "$files" ]
568 then
569 test -n "$cached" &&
570 die "--cached cannot be used with --files"
571 diff_cmd=diff-files
572 head=
575 cd_to_toplevel
576 # Get modified modules cared by user
577 modules=$(git $diff_cmd $cached --raw $head -- "$@" |
578 sane_egrep '^:([0-7]* )?160000' |
579 while read mod_src mod_dst sha1_src sha1_dst status name
581 # Always show modules deleted or type-changed (blob<->module)
582 test $status = D -o $status = T && echo "$name" && continue
583 # Also show added or modified modules which are checked out
584 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
585 echo "$name"
586 done
589 test -z "$modules" && return
591 git $diff_cmd $cached --raw $head -- $modules |
592 sane_egrep '^:([0-7]* )?160000' |
593 cut -c2- |
594 while read mod_src mod_dst sha1_src sha1_dst status name
596 if test -z "$cached" &&
597 test $sha1_dst = 0000000000000000000000000000000000000000
598 then
599 case "$mod_dst" in
600 160000)
601 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
603 100644 | 100755 | 120000)
604 sha1_dst=$(git hash-object $name)
606 000000)
607 ;; # removed
609 # unexpected type
610 echo >&2 "unexpected mode $mod_dst"
611 continue ;;
612 esac
614 missing_src=
615 missing_dst=
617 test $mod_src = 160000 &&
618 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
619 missing_src=t
621 test $mod_dst = 160000 &&
622 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
623 missing_dst=t
625 total_commits=
626 case "$missing_src,$missing_dst" in
628 errmsg=" Warn: $name doesn't contain commit $sha1_src"
631 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
633 t,t)
634 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
637 errmsg=
638 total_commits=$(
639 if test $mod_src = 160000 -a $mod_dst = 160000
640 then
641 range="$sha1_src...$sha1_dst"
642 elif test $mod_src = 160000
643 then
644 range=$sha1_src
645 else
646 range=$sha1_dst
648 GIT_DIR="$name/.git" \
649 git log --pretty=oneline --first-parent $range | wc -l
651 total_commits=" ($(($total_commits + 0)))"
653 esac
655 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
656 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
657 if test $status = T
658 then
659 if test $mod_dst = 160000
660 then
661 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
662 else
663 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
665 else
666 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
668 if test -n "$errmsg"
669 then
670 # Don't give error msg for modification whose dst is not submodule
671 # i.e. deleted or changed to blob
672 test $mod_dst = 160000 && echo "$errmsg"
673 else
674 if test $mod_src = 160000 -a $mod_dst = 160000
675 then
676 limit=
677 test $summary_limit -gt 0 && limit="-$summary_limit"
678 GIT_DIR="$name/.git" \
679 git log $limit --pretty='format: %m %s' \
680 --first-parent $sha1_src...$sha1_dst
681 elif test $mod_dst = 160000
682 then
683 GIT_DIR="$name/.git" \
684 git log --pretty='format: > %s' -1 $sha1_dst
685 else
686 GIT_DIR="$name/.git" \
687 git log --pretty='format: < %s' -1 $sha1_src
689 echo
691 echo
692 done |
693 if test -n "$for_status"; then
694 if [ -n "$files" ]; then
695 echo "# Submodules changed but not updated:"
696 else
697 echo "# Submodule changes to be committed:"
699 echo "#"
700 sed -e 's|^|# |' -e 's|^# $|#|'
701 else
706 # List all submodules, prefixed with:
707 # - submodule not initialized
708 # + different revision checked out
710 # If --cached was specified the revision in the index will be printed
711 # instead of the currently checked out revision.
713 # $@ = requested paths (default to all)
715 cmd_status()
717 # parse $args after "submodule ... status".
718 orig_args="$@"
719 while test $# -ne 0
721 case "$1" in
722 -q|--quiet)
723 GIT_QUIET=1
725 --cached)
726 cached=1
728 --recursive)
729 recursive=1
732 shift
733 break
736 usage
739 break
741 esac
742 shift
743 done
745 module_list "$@" |
746 while read mode sha1 stage path
748 name=$(module_name "$path") || exit
749 url=$(git config submodule."$name".url)
750 displaypath="$prefix$path"
751 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
752 then
753 say "-$sha1 $displaypath"
754 continue;
756 set_name_rev "$path" "$sha1"
757 if git diff-files --quiet -- "$path"
758 then
759 say " $sha1 $displaypath$revname"
760 else
761 if test -z "$cached"
762 then
763 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
764 set_name_rev "$path" "$sha1"
766 say "+$sha1 $displaypath$revname"
769 if test -n "$recursive"
770 then
772 prefix="$displaypath/"
773 unset GIT_DIR
774 cd "$path" &&
775 cmd_status $orig_args
776 ) ||
777 die "Failed to recurse into submodule path '$path'"
779 done
782 # Sync remote urls for submodules
783 # This makes the value for remote.$remote.url match the value
784 # specified in .gitmodules.
786 cmd_sync()
788 while test $# -ne 0
790 case "$1" in
791 -q|--quiet)
792 GIT_QUIET=1
793 shift
796 shift
797 break
800 usage
803 break
805 esac
806 done
807 cd_to_toplevel
808 module_list "$@" |
809 while read mode sha1 stage path
811 name=$(module_name "$path")
812 url=$(git config -f .gitmodules --get submodule."$name".url)
814 # Possibly a url relative to parent
815 case "$url" in
816 ./*|../*)
817 url=$(resolve_relative_url "$url") || exit
819 esac
821 if test -e "$path"/.git
822 then
824 unset GIT_DIR
825 cd "$path"
826 remote=$(get_default_remote)
827 say "Synchronizing submodule url for '$name'"
828 git config remote."$remote".url "$url"
831 done
834 # This loop parses the command line arguments to find the
835 # subcommand name to dispatch. Parsing of the subcommand specific
836 # options are primarily done by the subcommand implementations.
837 # Subcommand specific options such as --branch and --cached are
838 # parsed here as well, for backward compatibility.
840 while test $# != 0 && test -z "$command"
842 case "$1" in
843 add | foreach | init | update | status | summary | sync)
844 command=$1
846 -q|--quiet)
847 GIT_QUIET=1
849 -b|--branch)
850 case "$2" in
852 usage
854 esac
855 branch="$2"; shift
857 --cached)
858 cached="$1"
861 break
864 usage
867 break
869 esac
870 shift
871 done
873 # No command word defaults to "status"
874 test -n "$command" || command=status
876 # "-b branch" is accepted only by "add"
877 if test -n "$branch" && test "$command" != add
878 then
879 usage
882 # "--cached" is accepted only by "status" and "summary"
883 if test -n "$cached" && test "$command" != status -a "$command" != summary
884 then
885 usage
888 "cmd_$command" "$@"